// hlavickove subory *******************************************************
// GL a GLU kniznica
#include <GL/gl.h>
//#include <GL/glu.h>
// funkcie SDL kniznice
#include <SDL/SDL.h>

// .h subor
#include "OGLtexture.h"

// konstruktor *************************************************************
COGLtexture::COGLtexture()
{
 texture_id[0]=0;
}

// destruktor **************************************************************
COGLtexture::~COGLtexture()
{

}

// nahratie textury ********************************************************
int COGLtexture::LoadTexture(char *myfile)
{
 // alokovanie miesta pre data textury
 SDL_Surface *TextureImage[1];

 // nahratie suboru s bitmapou
 if ((TextureImage[0]=SDL_LoadBMP(myfile))) {
  glGenTextures(1,&texture_id[0]);
  // pripojenie textury
  glBindTexture(GL_TEXTURE_2D,texture_id[0]);
  // nastavenie LINEAR filteringu
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  // vygenerovanie textury
  glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage[0]->w,TextureImage[0]->h,
               0,GL_BGR,GL_UNSIGNED_BYTE,TextureImage[0]->pixels);
 }
 else return(1);

 // uvolnenie pouzitej pamate
 if (TextureImage[0]) SDL_FreeSurface(TextureImage[0]);

 return(0);
}

