// obrazok - sirka, vyska, data
typedef struct __BMPImage {
 unsigned long width;
 unsigned long height;
 unsigned char *data;
} _BMPImage;

typedef struct _TEXTURE {
 unsigned int w,h;
 unsigned char *data;
} TEXTURE;

// trieda premennych a funkcii pre pracu s BMP obrazkom
class CBMPImage {
public:
 CBMPImage();
 virtual ~CBMPImage();

 // nacitanie .bmp suboru
 int CBMPImage::BMPImage_load(char *fname);

 unsigned long get_width();
 unsigned long get_height();
 unsigned char *get_data();

 TEXTURE *open_bitmap(char *fname);
 void set_bitmap_transparent(TEXTURE *bmp,unsigned char r,
                                          unsigned char g,
                                          unsigned char b);
 void close_bitmap(TEXTURE *bmp);
private:
 _BMPImage bmp_image;
};

